
F8
==

This is support for the Fairchild F8. The syntax used for naken_asm
has been modernized a little bit. It should support all the old syntax
if this is really desired, but it's recommended not to use that.

Examples Of Changes
===================

When dealing with the ISAR register, the old syntax used S, U, and D where
S means the ISAR register itself, U means use the ISAR register and then
increment it by 1, and D means use the ISAR register and decrement by 1.

naken_asm will also support:

S: [ISAR]
U: [ISAR]+
D: [ISAR]-

The disassembly will show [ISAR], [ISAR]+, [ISAR]- by default just to make
things more clear.

So it's possible to do:

lr a, [5]      (lr a, 5 is the old syntax and assembles the same)
lr a, [isar]
lr a, [isar]+
lr a, [isar]-
lr a, isar

Where things in [ ] mean "address of" and without square brackets it means
to act upon the register itself.

