;; PN532 RFID Chip.

;; Commands.

; Miscellaneous.
PN532_CMD_DIAGNOSE                 equ 0x00
PN532_CMD_GET_FIRMWARE_VERSION     equ 0x02
PN532_CMD_GET_GENERAL_STATUS       equ 0x04
PN532_CMD_GET_READ_REGISTER        equ 0x06
PN532_CMD_GET_WRITE_REGISTER       equ 0x08
PN532_CMD_READ_GPIO                equ 0x0c
PN532_CMD_WRITE_GPIO               equ 0x0e
PN532_CMD_SET_SERIAL_BAUD_RATE     equ 0x10
PN532_CMD_SET_PARAMETERS           equ 0x12
PN532_CMD_SAM_CONFIGURATION        equ 0x14
PN532_CMD_POWER_DOWN               equ 0x16

; RF Communication.
PN532_CMD_RF_CONFIGURATION         equ 0x32
PN532_CMD_RF_REGULATION_TEST       equ 0x58

; Initiator.
PN532_CMD_IN_JUMP_FOR_DEP          equ 0x56
PN532_CMD_IN_JUMP_FOR_PSL          equ 0x46
PN532_CMD_IN_LIST_PASSIVE_TARGET   equ 0x4a
PN532_CMD_IN_ATR                   equ 0x50
PN532_CMD_IN_PSL                   equ 0x4e
PN532_CMD_IN_DATA_EXCHANGE         equ 0x40
PN532_CMD_IN_COMMUNICATE_THRU      equ 0x42
PN532_CMD_IN_DESELECT              equ 0x44
PN532_CMD_IN_RELEASE               equ 0x52
PN532_CMD_IN_SELECT                equ 0x54
PN532_CMD_IN_AUTO_POLL             equ 0x60

; Target.
PN532_CMD_TG_INIT_AS_TARGET        equ 0x8c
PN532_CMD_TG_SET_GENERAL_BYTES     equ 0x92
PN532_CMD_TG_GET_DATA              equ 0x86
PN532_CMD_TG_SET_DATA              equ 0x8e
PN532_CMD_TG_SET_META_DATA         equ 0x94
PN532_CMD_TG_GET_INITIATOR_COMMAND equ 0x88
PN532_CMD_TG_RESPONSE_TO_INITIATOR equ 0x90
PN532_CMD_TG_GET_TARGET_STATUS     equ 0x8a

;; Error codes (7.1 Page 67).
PN532_ERROR_TIMEOUT             equ 0x01
PN532_ERROR_CRC                 equ 0x02
PN532_ERROR_PARITY              equ 0x03
PN532_ERROR_BIT_COUNT           equ 0x04
PN532_ERROR_FRAME               equ 0x05
PN532_ERROR_COLLISION           equ 0x06
PN532_ERROR_BUFER_SIZE          equ 0x07
PN532_ERROR_OVERFLOW            equ 0x09
PN532_ERROR_INACTIVE            equ 0x0a
PN532_ERROR_RF_PROTOCL          equ 0x0b
PN532_ERROR_TEMPERATURE         equ 0x0d
PN532_ERROR_INTERNAL_OVERFLOW   equ 0x0e
PN532_ERROR_INVALID_PARAM       equ 0x10
PN532_ERROR_DEP_INVALID_COMMAND equ 0x12
PN532_ERROR_DEP_DATA_FORMAT     equ 0x13
PN532_ERROR_AUTH_ERROR          equ 0x14
PN532_ERROR_CHECK_BYTE          equ 0x23
PN532_ERROR_DEP_BAD_STATE       equ 0x25
PN532_ERROR_ILLEGAL_OP          equ 0x26
PN532_ERROR_CONTEXT             equ 0x27
PN532_ERROR_RELEASED            equ 0x29
PN532_ERROR_ID_MISMATCH         equ 0x2a
PN532_ERROR_DISAPPEARED         equ 0x2b
PN532_ERROR_NFCID_MISMATCH      equ 0x2c
PN532_ERROR_OVERCURRENT         equ 0x2c
PN532_ERROR_DEP_MISSING_NAD     equ 0x2c

